!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{var f;"undefined"!=typeof window?f=window:"undefined"!=typeof global?f=global:"undefined"!=typeof self&&(f=self),f.creat=e()}}(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
var utils = require('./lib/utils');
var types = utils.types;

var tags = ['a', 'abbr', 'address', 'area', 'article', 'aside', 'audio', 'b', 'base', 'bdi', 'bdo', 'blockquote', 'body', 'br', 'button', 'canvas', 'caption', 'cite', 'code', 'col', 'colgroup', 'content', 'data', 'datalist', 'dd', 'del', 'details', 'dfn', 'dialog', 'div', 'dl', 'dt', 'em', 'embed', 'fieldset', 'figcaption', 'figure', 'footer', 'form', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'head', 'header', 'hr', 'html', 'i', 'iframe', 'img', 'input', 'ins', 'kbd', 'keygen', 'label', 'legend', 'li', 'link', 'main', 'map', 'mark', 'menu', 'menuitem', 'meta', 'meter', 'nav', 'noscript', 'object', 'ol', 'optgroup', 'option', 'output', 'p', 'param', 'picture', 'pre', 'progress', 'q', 'rp', 'rt', 'ruby', 's', 'samp', 'script', 'section', 'select', 'shadow', 'small', 'source', 'span', 'strong', 'style', 'sub', 'summary', 'sup', 'table', 'tbody', 'template', 'textarea', 'tfoot', 'th', 'thead', 'time', 'title', 'tr', 'track'];

var creat = {};

tags.forEach(function(tag) {
	creat[tag] = function(options) {
		var options = options || {};
		var element = document.createElement(tag);
		var context = options.context || {};
		var escape = options.escape || true;
		var classes = options.classes || '';
		delete options['context'];
		delete options['escape'];

		if (classes) {
			utils.add(element, classes);
			delete options['classes'];
		}

		if (options.content) {
			var content = options.content;

			if (types.isElement(content)) {
				element.appendChild(content);
			} else

			if (types.isString(content)) {
				element.innerHTML = content;
			} else

			if (types.isFunction(content)) {
				children = content.call(null, context);
				element.appendChild(children);
			} else

			if (types.isArray(content)) {

				for (var i = 0, l = content.length; i < l; i++) {
					var arg = content[i];
					if (types.isElement(arg)) {
						element.appendChild(arg);
					} else if (types.isFunction(arg)) {
						arg.call()
					}
				}

			}

			delete options['content'];
		}

		utils.add(element, options);
		
		return element;
	};
});

creat.fragment = function() {
	var args = arguments;
	console.log(args.length);
	if (!args.length) return document.createDocumentFragment();
};

module.exports = creat;
},{"./lib/utils":2}],2:[function(require,module,exports){
var utils = {};

var types = {
	isElement : function(node) {
		return node.nodeName && (node.nodeType === 1 || node.nodeType === 9);
	},
	isString : function(value) {
		return Object.prototype.toString.call(value) === '[object String]';
	},
	isArray : function(obj) {
		return Object.prototype.toString.call(obj) === '[object Array]';
	},
	isObject : function(obj) {
		return obj !== null && Object.prototype.toString.call(obj) === '[object Object]';
	},
	isFunction : function(obj) {
		return Object.prototype.toString.call(obj) === '[object Function]';
	}
};

var classes = {
	get : function(element) {
		return element.classList ? element.classList : element.className.split(/\s+/);
	},
	has : function(element, name) {
		return element.classList ? element.classList.contains(name) : !! ~utils.index(classes.get(element), name);
	},
	add : function(element, name) {
		name = name.trim();
		if (element.classList) {
			return element.classList.add(name);
		}
		classes = classes.get(element);
		var index = utils.index(classes, name);
		if (!~index) classes.push(name);
		element.className = classes.join(' ');
		return element;
	},

	remove : function(element, name) {
		name = name.trim();
		if (element.classList) {
			return element.classList.remove(name);
		}
		classes = classes.get(element);
		var index = index(classes, name);
		if (~index) classes.splice(index, 1);
		element.className = classes.join(' ');
		return element;
	},

	toggleClass : function(element, name) {
		name = name.trim();
		if (element.classList) {
			return element.classList.toggle(name);
		}
		return classes.has(element, name) ? classes.remove(element, name) : classes.add(element, name);
	},

};

utils.types = types;

utils.index = function(list, item) {
	return Array.prototype.indexOf.call(list, item);
};

utils.hasProp = function(obj, prop) {
	return obj !== null && Object.prototype.hasOwnProperty.call(obj, prop);
};

utils.add = function(element) {
	var args = Array.prototype.slice.call(arguments, 1);

	for (var i = 0, l = args.length; i < l; i++) {
		var arg = args[i];

		if (types.isString(arg)) {
			classes.add(element, arg);
		} else

		if (types.isArray(arg)) {
			for (var a = 0, b = arg.length; a < b; a++) {
				classes.add(element, arg[a]);
			}
		} else

		if (types.isObject(arg)) {
			for (var property in arg) {
				if (property !== null && utils.hasProp(arg, property)) {
					element.setAttribute(property, arg[property]);
				}
			}
		}
	}
};

module.exports = utils;
},{}]},{},[1])(1)
});